// подключение библиотек
#define BLYNK_PRINT Serial

#include <SPI.h>
#include <Ethernet.h>
#include <BlynkSimpleEthernet.h>
#include <Servo.h>
#include <SimpleTimer.h>
#include <BH1750.h>
#include <Wire.h>

// создание экземпляра объекта BH1750
BH1750 light1;
// создание экземпляра объекта Servo
Servo servo1;
// создание экземпляра объекта SimpleTimer
SimpleTimer timer;

// токен авторизации для проекта на смартфона
char auth[] = "16bcc28b557d4c45b3fd380f5cf8da66";

// MAC-адрес и настройки сети для Ethernet shield
byte arduino_mac[] = { 0xDE, 0xED, 0xBA, 0xFE, 0xFE, 0xED };
IPAddress arduino_ip ( 192, 168, 0, 120);
IPAddress dns_ip ( 192, 168, 1, 1);
IPAddress gateway_ip ( 192, 168, 0, 28);
IPAddress subnet_mask(255, 255, 255, 0);
// получение значения с виртуального порта V0
BLYNK_WRITE(0)
  {
  int valV0=param.asInt();
  Serial.print("virtual pin0=");Serial.println(valV0);
  servo1.write(valV0); // поворот сервопривода
  }

void setup()
  {
  Serial.begin(9600);
  Blynk.begin(auth, "cloud.blynk.cc", 8442, arduino_ip, dns_ip, gateway_ip, subnet_mask,arduino_mac);
  servo1.attach(9); // подключает переменную servoк выходу 9
  light1.begin();   // запуск датчика BH1750
  timer.setInterval(10000, sendBH1750);
  }

void loop()
  {
  Blynk.run();
  timer.run(); 
  }

void sendBH1750()
  {
  // получить значение освещенности в lx
  uint16_t lux = light1.readLightLevel();  
  Serial.println(lux);
  // отправка значения освещенности
  Blynk.virtualWrite(1, lux);
  }

