// функции получения данных с датчиков
// 
// 


// получить показания с датчика температуры ds18b20
// num=   0-воздуха, 1-почвы
float get_temp(int num)
 {
byte i;
byte present = 0;
byte data[12];
int Temp;
float fTemp;


  ds.reset();
  ds.select(addr[num]);
  ds.write(0x44,1);        // start conversion, with parasite power on at the end
  delay(1000);             // подождать 750ms is enough, maybe not

  present = ds.reset();
  ds.select(addr[num]);
  ds.write(0xBE);          // Read Scratchpad
  for ( i = 0; i < 9; i++) {         // we need 9 bytes
    data[i] = ds.read();
  }
  Temp=(data[1]<<8)+data[0];  
  Temp=Temp;       //divide by 16 to get pure celcius readout

  fTemp=float(Temp/16)+float((Temp%16)*100)/16/100;
    
  return fTemp;
 }

// получить показания с датчика DHT
float get_dht()
  {
    float fhumidity;
    
    fhumidity=dht.readHumidity();
    if (isnan(fhumidity)) 
      {
      return 1000.0;
      } 
    return fhumidity;
  }

// получить показания с датчика SoilMoisture
float get_soilMoisture()
  {
   float percentSoilMoisture;
    
   percentSoilMoisture=map(analogRead(PIN_SOILMOISTURE),MIN_SOILMOISTURE,MAX_SOILMOISTURE,0,100);
   return percentSoilMoisture;
  }

// получить показания освещенности
float get_light()
  {
    int light;
    
    light=map(analogRead(PIN_LIGHT),MIN_LIGHT,MAX_LIGHT,0,100);
    return float(light);
  }
 // получить показания LM35 - датчик температуры
float get_lm35()
  {
    double val=analogRead(PIN_LM35);
    double voltage=val*5.00/1024;
    double temp=voltage*100-273;
    return float(temp);
  }
  // получить показания GPS
float get_GPS()
  {
  }
