// функции ethernet
//
// запустить ethernet  
void ethernet_begin()
  {
  if(DHCP==0)
    {
    if(Ethernet.begin(arduino_mac)==0)
      Serial.println("dhcp - error");
    else
      Serial.println("dhcp - ok");
    }  
  else
    {  
    IPAddress arduino_ip(mip[0],mip[1],mip[2],mip[3]);
    IPAddress dns_ip(mdns[0],mdns[1],mdns[2],mdns[3]);
    IPAddress gateway_ip(mgateway[0],mgateway[1],mgateway[2],mgateway[3]);
    IPAddress subnet_mask(mmask[0],mmask[1],mmask[2],mmask[3]);  
    Ethernet.begin(arduino_mac, arduino_ip, dns_ip, gateway_ip, subnet_mask);
    }
  }
// вывести ip-адрес
void print_ip()
  {
  Serial.print("My IP address: ");
  for (byte thisByte = 0; thisByte < 4; thisByte++) {
    // print the value of each byte of the IP address:
    Serial.print(Ethernet.localIP()[thisByte], DEC);
    Serial.print(".");
  }
  Serial.println();
  Serial.print("My SUBNET: ");
  for (byte thisByte = 0; thisByte < 4; thisByte++) {
    // print the value of each byte of the IP address:
    Serial.print(Ethernet.subnetMask()[thisByte], DEC);
    Serial.print(".");
  }
  Serial.println();
  Serial.print("My GATEWAYIP: ");
  for (byte thisByte = 0; thisByte < 4; thisByte++) {
    // print the value of each byte of the IP address:
    Serial.print(Ethernet.gatewayIP()[thisByte], DEC);
    Serial.print(".");
  }
  Serial.println();
  Serial.print("My DNS: ");
  for (byte thisByte = 0; thisByte < 4; thisByte++) {
    // print the value of each byte of the IP address:
    Serial.print(Ethernet.dnsServerIP()[thisByte], DEC);
    Serial.print(".");
  }
  Serial.println();
  }
// отправка данных в ThingWorx
void updateValues(double values[] , EthernetClient &client, char server[], char appKey[], char thingName[], char serviceName[], char* sensorNames[])
{
  //build the String with the data that you will send
  //through REST calls to your TWX server
  char data[80];
  strcpy(data, "?appKey=");
  strcat(data, appKey);
  strcat(data, "&method=post&x-thingworx-session=true");
   
  // if you get a connection, report back via serial:
  if (client.connect(server, 80)) 
    {
    Serial.println("connected");
    // send the HTTP POST request:
    client.print("POST /Thingworx/Things/");
    client.print(thingName);
    client.print("/Services/");
    client.print(serviceName);
    client.print(data);
    //client.print("<");
   for (int idx = 0; idx < propertyCount; idx++)
    {
      client.print("&");
      client.print(propertyNames[idx]);
      client.print("=");
      client.print(propertyValues[idx],digitValues[idx]);
    }
    //client.print(">");
    client.println(" HTTP/1.1");
    client.print("Host: ");
    client.println(server);
    client.println("Content-Type: text/html");
    client.println();

     client.stop();
    lastConnectionTime = millis();
    
    // print the request out
    Serial.print("POST /Thingworx/Things/");
    Serial.print(thingName);
    Serial.print("/Services/");
    Serial.print(serviceName);
    Serial.print(data);
    Serial.print("<");
    //Serial.print("&ValIdDevice=");
    //Serial.print(ID);
    //Serial.print("&ValLocationDevice=");
    //Serial.print(LAT);
    //Serial.print(" : ");
    //Serial.print(LON);
    for (int idx = 0; idx < propertyCount; idx++)
    {
      Serial.print("&");
      Serial.print(propertyNames[idx]);
      Serial.print("=");
      Serial.print(propertyValues[idx]);
    }
    Serial.print(">");
    Serial.println(" HTTP/1.1");
    Serial.print("Host: ");
    Serial.println(server);
    Serial.println("Content-Type: text/html");
    Serial.println();


    }
  else
    {
    // kf you didn't get a connection to the server:
    Serial.println("the connection could not be established");
    client.stop();
    }
}
