// подключение библиотеки
#include "ThingSpeak.h"
// Use wired ethernet shield
#include <SPI.h>
#include <Ethernet.h>
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED};
EthernetClient client;
// IP-адрес, назначаемый Ethernet Shield:
byte ip[] = { 192, 168, 0, 119 };
// IP-адрес, dns сервера:
byte sdns[] = { 192, 168, 1, 1 };
// адрес шлюза:
byte gateway[] = { 192, 168, 0, 28 };
// маска:
byte subnet[] = { 255, 255, 255, 0 };

// данные канала
unsigned long myChannelNumber = 314294;
const char * myWriteAPIKey = "8YTRJ3NX1RJTAJU3";

unsigned long millis1=0;


//пин подключения счетчика A3
int currentPin = 3;              
double kilos = 0.03;
int peakPower = 0;

void setup() {

  // запуск Ethernet
  Ethernet.begin(mac,ip,sdns,gateway,subnet);
  // секунда для инициализации Ethernet
  delay(1000);
  // инициализация ThingSpeak
  ThingSpeak.begin(client);
  // запуск последовательного порта
  Serial.begin(9600);            
  Serial.println("Running");
}

void loop() {
  int current = 0;
  int maxCurrent = 0;
  int minCurrent = 1000;
  // 200 выборок для получения мин. и макс. значения тока 
  for (int i=0 ; i<=200 ; i++)  
  {
    current = analogRead(currentPin);    
    if(current >= maxCurrent)
      maxCurrent = current;
    else if(current <= minCurrent)
      minCurrent = current;
  }
  if (maxCurrent <= 517)
  {
    maxCurrent = 516;
  }
  double RMSCurrent = ((maxCurrent - 516)*0.707)/11.8337; 
  // потребленная мощность в Ватт   
  int RMSPower = 220*RMSCurrent;    
  if (RMSPower > peakPower)
  {
    peakPower = RMSPower;
  }
  //подсчет в киливатт-час
  kilos = kilos + (RMSPower * (2.05/60/60/1000));    
  delay (2000);
  Serial.print(RMSCurrent);
  Serial.println("A");
  Serial.print((float)kilos);
  Serial.println("kWh");

  if(millis()-millis1>30*1000) {
     // отправка данных в сервис ThingSpeak
     ThingSpeak.writeField(myChannelNumber, 1, (float)kilos, myWriteAPIKey);
     millis1=millis();
     Serial.println("SEND...........................................");
  }
}
