// подключение библиотеки
#include <EEPROM.h>
// начальные показания
unsigned int dataBetar15D=0;

void setup() {
  // начальная установка значений в EEPROM при первом запусе
  if(get_param2_EEPROM(0)==0xffff)
     save_param2_EEPROM(0, dataBetar15D);
  // запуск последовательного порта
  Serial.begin(9600);
  // получение показаний из EEPROM
  dataBetar15D=get_param2_EEPROM(0);
  // вывод показаний текущих
  Serial.print ("dataBetar15D="); Serial.println(dataBetar15D);
  // запускаем прерывание
  attachInterrupt(0,addDataBetar15D,RISING);
}

void loop() {;}

// получить значения параметра из EEPROM
int get_param2_EEPROM(int addr) {
  int retval=((EEPROM.read(addr)<<8)+EEPROM.read(addr+1));
  return retval; 
  }
// сохранить значения параметра в EEPROM
void save_param2_EEPROM(int addr,int val) {
  EEPROM.write(addr,highByte(val));  
  EEPROM.write(addr+1,lowByte(val));  
  }
// прерывание – добавить 10 л
void addDataBetar15D() {
   detachInterrupt(0);
   dataBetar15D= dataBetar15D+10;
   // сохранить в EEPROM
   save_param2_EEPROM(0, dataBetar15D);
   attachInterrupt(0, addDataBetar15D, RISING);  
}
