 // подключение библиотеки
#include "ThingSpeak.h"
// Use wired ethernet shield
#include <SPI.h>
#include <Ethernet.h>
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED};
EthernetClient client;
// IP-адрес, назначаемый Ethernet Shield:
byte ip[] = { 192, 168, 0, 119 };
// IP-адрес, dns сервера:
byte sdns[] = { 192, 168, 1, 1 };
// адрес шлюза:
byte gateway[] = { 192, 168, 0, 28 };
// маска:
byte subnet[] = { 255, 255, 255, 0 };

// данные канала
unsigned long myChannelNumber = 324829;
const char * myWriteAPIKey = "CT4U51S33J4V5OWC";

// подключение библиотеки
#include <EEPROM.h>
// начальные показания
unsigned int dataBetar15D=0;
unsigned int dataBetar15Dpr=0;


void setup() {

  // запуск Ethernet
  Ethernet.begin(mac,ip,sdns,gateway,subnet);
  // секунда для инициализации Ethernet
  delay(1000);
  // инициализация ThingSpeak
  ThingSpeak.begin(client);
  // запуск последовательного порта
  Serial.begin(9600);            
  // начальная установка значений в EEPROM при первом запусе
  if(get_param2_EEPROM(0)==0xffff)
     save_param2_EEPROM(0, dataBetar15D);
  // получение показаний из EEPROM
  dataBetar15D=get_param2_EEPROM(0);
  dataBetar15Dpr=dataBetar15D;
  // вывод показаний текущих
  Serial.print ("dataBetar15D="); Serial.println(dataBetar15D);
  // запускаем прерывание
  attachInterrupt(0,addDataBetar15D,RISING);
  Serial.println("Running");
}

void loop() {

  if(dataBetar15Dpr!=dataBetar15D) {
     // отправка данных в сервис ThingSpeak
     ThingSpeak.writeField(myChannelNumber, 1, (float)dataBetar15D, myWriteAPIKey);
     dataBetar15Dpr=dataBetar15D;
  }
}
// получить значения параметра из EEPROM
int get_param2_EEPROM(int addr) {
  int retval=((EEPROM.read(addr)<<8)+EEPROM.read(addr+1));
  return retval; 
  }
// сохранить значения параметра в EEPROM
void save_param2_EEPROM(int addr,int val) {
  EEPROM.write(addr,highByte(val));  
  EEPROM.write(addr+1,lowByte(val));  
  }
// прерывание – добавить 10 л
void addDataBetar15D() {
   detachInterrupt(0);
   dataBetar15D= dataBetar15D+10;
   // сохранить в EEPROM
   save_param2_EEPROM(0, dataBetar15D);
   attachInterrupt(0, addDataBetar15D, RISING);  
}
