// Пример для книги
// управление реле из web ajax


// для Ethernet и SD
#include <SPI.h>
#include <Ethernet.h>
#include <Flash.h>
#include <SD.h>
#include <TinyWebServer.h>


//unsigned char date_time[]="01.01.1970 00:00";
char b[5];
String str1;
String createfile;
char charcreatefile[10];

boolean file_handler(TinyWebServer& web_server);
boolean index_handler(TinyWebServer& web_server);

boolean has_filesystem = true;
Sd2Card card;
SdVolume volume;
SdFile root;
SdFile file;

File dayFile;

// relay
int pinrelays[]={5,6,7};

static uint8_t mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };

// Don't forget to modify the IP to an available one on your home network
byte ip[] = { 192, 168, 1, 178 };

const int sdChipSelect = 4;            // SD card chipSelect

TinyWebServer::PathHandler handlers[] = {
  {"/", TinyWebServer::GET, &index_handler },
  {"/setrelay" "*", TinyWebServer::GET, &set_relays },
  {"/" "*", TinyWebServer::GET, &file_handler },
  {NULL},
};

// главная страница 
boolean index_handler(TinyWebServer& web_server) {
  web_server.send_error_code(200);
  web_server.send_content_type("text/html");
  web_server.end_headers();
  web_server << F("<html><body><h1>Menu</h1>");
  web_server << F("<a href='/relays'>Set relays</a><br>");
  web_server << F("<br>");
  web_server << F("<a href='/servos'>Set servos</a><br>");
  web_server << F("<br>");
  web_server << F("<a href='/sensors'>Get data sensors</a><br>");
  web_server << F("</body></html>");
 return true;
}

// страницы с SD карты 
boolean file_handler(TinyWebServer& web_server) {

  if(!has_filesystem) {
    web_server.send_error_code(500);
    web_server << F("Internal Server Error");
    return true;
  }
  char* filename = TinyWebServer::get_file_from_path(web_server.get_path());
  if(!filename) {
  	web_server.send_error_code(400);
  	web_server << F("Bad Request1");
  	return true;
  }
  send_file_name(web_server, filename);
  free(filename);
  return true;
}

void send_file_name(TinyWebServer& web_server, const char* filename) {

  TinyWebServer::MimeType mime_type
    = TinyWebServer::get_mime_type_from_filename(filename);
  if (file.open(&root, filename, O_READ)) {
    web_server.send_error_code(200);
    web_server.send_content_type(mime_type);
    web_server.end_headers();

    Serial << F("Read file "); Serial.println(filename);
    web_server.send_file(file);
    file.close();
  } else {
    web_server.send_error_code(404);
    web_server.send_content_type("text/plain");
    web_server.end_headers();

    Serial << F("Could not find file: "); Serial.println(filename);
    web_server << F("404 - ERROR ") << filename << "\n";
  }
}
// включение/выключение реле по запросу
boolean set_relays(TinyWebServer& web_server) {

  char* filename = TinyWebServer::get_file_from_path(web_server.get_path());
  String str1(filename);
  Serial.println(str1);
  
  digitalWrite(pinrelays[convert1(str1,13,14)-1],convert1(str1,21,22));
  
  if(!filename) {
  	web_server.send_error_code(400);
  	web_server << F("Bad Request1");
  	return true;
  }  
  
    web_server.send_error_code(200);
    web_server.send_content_type("text/xml");
    web_server.end_headers();
    web_server << F("<?xml version = \"1.0\" ?>");
    web_server << F("<inputs>");
    web_server << F("<message>relay ")<<str1.substring(13,14);
    if(convert1(str1,21,22)>0)
        web_server << F(" on");
    else
        web_server << F(" off");
    //  web_server << F("<message>relay")<<<<F(" on");
    web_server << F("</message>");
    web_server << F("</inputs>");
    return true;  
}


int convert1(String strstr,int start1,int end1)
  {
  char *strint=new char[2];
  String str3;
  str3=strstr.substring(start1,end1);str3.toCharArray(strint,2);
  return atoi(strint);  
  }

boolean has_ip_address = false;
TinyWebServer web = TinyWebServer(handlers, NULL);

const char* ip_to_str(const uint8_t* ipAddr)
{
  static char buf[16];
  sprintf(buf, "%d.%d.%d.%d\0", ipAddr[0], ipAddr[1], ipAddr[2], ipAddr[3]);
  return buf;
}



void setup() {
  Serial.begin(9600);
  // реле на OUTPUT
  for(int i=0;i<3;i++)
    {pinMode(pinrelays[i],OUTPUT);
     digitalWrite(pinrelays[i],LOW);
    }
    
  Serial << F("Free RAM: ") << FreeRam() << "\n";

  pinMode(10, OUTPUT); // set the SS pin as an output (necessary!)
  digitalWrite(10, HIGH); // but turn off the W5100 chip!
  // initialize the SD card

  Serial << F("Setting up SD card...\n");

  if (!card.init(SPI_FULL_SPEED, 4)) {
    Serial << F("card failed\n");
    has_filesystem = false;
  }
  // initialize a FAT volume
  if (!volume.init(&card)) {
    Serial << F("vol.init failed!\n");
    has_filesystem = false;
  }
  if (!root.openRoot(&volume)) {
    Serial << F("openRoot failed");
    has_filesystem = false;
  }

  Serial << F("Setting up the Ethernet card...\n");
  Ethernet.begin(mac, ip);

  // Start the web server.
  Serial << F("Web server starting...\n");
  web.begin();

  Serial << F("Free RAM: ") << FreeRam() << "\n";

  Serial << F("Ready to accept HTTP requests.\n\n");
  delay(500);
}

void loop() {
  web.process();  
}


