#include <SPI.h>
#include <Ethernet.h>
#include <HttpClient.h>
#include <Xively.h>

// MAC address for your Ethernet shield
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
// Mac address should be different for each device in your LAN
byte arduino_mac[] = { 0xDE, 0xED, 0xBA, 0xFE, 0xFE, 0xED };
IPAddress arduino_ip ( 192,   168,   0,  120);
IPAddress dns_ip     (  192,   168,   1,   1);
IPAddress gateway_ip ( 192,   168,   0,   28);
IPAddress subnet_mask(255, 255, 255,   0);
// Your Xively key to let you upload data
char xivelyKey[] = "x82lxX5skPez3TJEVAFcBxX1GzSk0Pd3Cu7jEvsTveuZNC8t";

#include <Wire.h>
#include <BH1750.h>
BH1750 lightMeter;

// Define the strings for our datastream IDs
char sensorId[] = "BH1750";
XivelyDatastream datastreams[] = {
  XivelyDatastream(sensorId, strlen(sensorId), DATASTREAM_FLOAT),
};
// Finally, wrap the datastreams into a feed
XivelyFeed feed(991165348, datastreams, 1 /* number of datastreams */);

EthernetClient client;
XivelyClient xivelyclient(client);

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  lightMeter.begin();
  
  Serial.println("Starting single datastream upload to Xively...");
  Serial.println();

  Ethernet.begin(mac,arduino_ip,dns_ip,gateway_ip,subnet_mask);
  //while Ethernet.begin(mac,arduino_ip,dns_ip,gateway_ip,subnet_mask) != 1)
  ///{
  //  Serial.println("Error getting IP address via DHCP, trying again...");
  //  delay(15000);
  //}
  Serial.println(Ethernet.localIP());
}

void loop() {
  //int sensorValue = analogRead(sensorPin);

  uint16_t lux = lightMeter.readLightLevel();
  datastreams[0].setFloat(lux);

  Serial.print("BH1750 sensor value ");
  Serial.println(datastreams[0].getFloat());

  Serial.println("Uploading it to Xively");
  int ret = xivelyclient.put(feed, xivelyKey);
  Serial.print("xivelyclient.put returned ");
  Serial.println(ret);

  Serial.println();
  delay(45000);
}
