#include <SPI.h>
#include <Ethernet.h>
#include <OneWire.h>
#include <Wire.h>
#include <BH1750.h>
BH1750 light1;
#include "DHT.h"
DHT dht(8, DHTTYPE);
OneWire  ds(7);  // on pin 7

// датчик 1
/**/
byte mac[] = { 0xAA, 0xBB, 0xCC, 0xDD, 0xEE, 0xF1 };
byte ip[] = { 192, 168, 1, 121 };    
EthernetServer server(10001);
byte my_addr[8]={0x28,0x2A,0x78,0x65,5,0,0,0x10};
/**/
// датчик 2
/*
byte mac[] = { 0xAA, 0xBB, 0xCC, 0xDD, 0xEE, 0xF2 };
byte ip[] = { 192, 168, 0, 122 };    
EthernetServer server(10002);
byte my_addr[8]={0x28,0x1,0x65,0x65,5,0,0,0xCE};
*/
int count_motion=0;
uint16_t count_sound=0;

void setup() {
  Serial.begin(9600);
  Serial.println("start");
  Ethernet.begin(mac, ip);
  // запуск сервера
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());
  
  Wire.begin();
  delay(1000);
  light1.begin();
  attachInterrupt(0,motion,RISING);

}

void loop () 
 {
  EthernetClient client = server.available();
  if (client) {
    // an http request ends with a blank line
    boolean currentLineIsBlank = true;
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
        // if you've gotten to the end of the line (received a newline
        // character) and the line is blank, the http request has ended,
        // so you can send a reply
        if (c == '\n' && currentLineIsBlank) {
          // send a standard http response header
          client.println("HTTP/1.1 200 OK");
          client.println("Content-Type: text/html");
          client.println();
          
          client.print('{');
          client.print('"');client.print("meteo");client.print('"');client.println(":");
          client.print('{');
         
            int Temp=get_temp();
            //Serial.print(Temp/16);
            //Serial.print(".");
            //Serial.print(((Temp%16)*100)/16);
            //Serial.println();
            client.print('"');client.print("temp1");client.print('"');client.print(":");
            client.print('"');client.print(Temp/16);
            client.print(".");
            client.print(((Temp%16)*100)/16);client.print('"');client.print(',');
           float h = dht.readHumidity();
           client.print('"');client.print("humidity1");client.print('"');client.print(":");
           client.print('"');client.print(h);client.print('"');
           client.print(',');
           // bh1750
           uint16_t lux = light1.readLightLevel();
           client.print('"');client.print("lux1");client.print('"');client.print(":");
           client.print('"');client.print(lux);client.print('"');
           client.print(',');
           // sound 
           client.print('"');client.print("sound1");client.print('"');client.print(":");
           client.print('"');client.print(count_sound);client.print('"');
           client.print(',');
           count_sound=0;
           //датчик движения
           client.print('"');client.print("motion1");client.print('"');client.print(":");
           client.print('"');client.print(count_motion);client.print('"');
           client.println("}");
           client.print("}");
           count_motion=0;
        break;
        }
        if (c == '\n') {
          // you're starting a new line
          currentLineIsBlank = true;
        } 
        else if (c != '\r') {
          // you've gotten a character on the current line
          currentLineIsBlank = false;
        }
      }
    }
    // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client.stop();
  }
  // sound
  if(analogRead(A0)<500)
    {count_sound++;delay(1000);}
 }
// получение тмпературы датчика
int get_temp()
 {
byte i;
byte present = 0;
byte data[12];
byte addr[8];
int Temp;

  ds.reset();
  ds.select(my_addr);
  ds.write(0x44,1);        // start conversion, with parasite power on at the end
  delay(1000);     // maybe 750ms is enough, maybe not
  // we might do a ds.depower() here, but the reset will take care of it.

  present = ds.reset();
  ds.select(my_addr);
  ds.write(0xBE);          // Read Scratchpad
  for ( i = 0; i < 9; i++) {         // we need 9 bytes
    data[i] = ds.read();
  }
  Temp=(data[1]<<8)+data[0];//take the two bytes from the response relating to temperature

  Temp=Temp;//divide by 16 to get pure celcius readout
  
  return Temp;
 }
 
 // обработка прерывания ик датчика движения
//  
void motion()
  {
  detachInterrupt(0);
  count_motion++;
  attachInterrupt(0,motion,RISING);
  }
