#include <Wire.h>
 
int clockAddress = 0x68;  // I2C адрес микросхемы
byte second, minute, hour, dayOfWeek, day, dayOfMonth, month, year;
  
#define DS3231_SCL 0
#define DS3231_SDA 2

#include <ESP8266WiFi.h>
#include <WiFiClient.h>
 
//const char* ssid     = "ardrone2_060602";
const char* ssid     = "MacBook-Pro-Victor";
const char* password = "19101966";
 
const char* host = "cbr.ru";
String euro="0000000";
String dollar="000000";

#include "Adafruit_Thermal.h"
Adafruit_Thermal printer(&Serial);     // Pass addr to printer constructor

  
void setup() {
  // запустить Wire
  Wire.begin(DS3231_SCL, DS3231_SDA);
  // запуск последовательного порта
  Serial.begin(19200);  
  // инициализация принтера
  printer.begin();  
  delay(3000);      
  // настройки по умолчанию
  printer.wake(); 
  printer.setDefault();
  printer.println();
  printer.println();
  delay(1000);  
  printer.println("test ");
  printer.println("esp8266 iot");
  printer.println("thermal printer");

  delay(10000);
  // подсоединение к WiFi точке доступа
  //Serial.println();
  //Serial.println();
  //Serial.print("Connecting to ");
  //Serial.println(ssid);
   
  WiFi.mode(WIFI_STA);
  //WiFi.begin(ssid);
  WiFi.begin(ssid, password);
   
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    //Serial.print(".");
  }
  printer.println("WiFi - ok ");
  printer.println();
  printer.println();
  printer.println();
 
  //Serial.println("");
  //Serial.println("WiFi connected");  
  //Serial.println("IP address: ");
  //Serial.println(WiFi.localIP());
 
}
 
void loop() { 

  delay(30000);
  // показать время
  getDateDs3231(); 
  String s = getTimeStr();
  //Serial.println(s);

  //Serial.print("connecting to ");
  //Serial.println(host);
   
  // создаем TCP соединение
  WiFiClient client;
  const int httpPort = 80;
  if (!client.connect(host, httpPort)) {
    //Serial.println("connection failed");
    return;
  }
   
  // создаем строку URL
  String url = "/scripts/XML_daily.asp?date_req="+getDateStr();
    
  //Serial.print("Requesting URL: ");
  //Serial.println(url);
   
  // отправить данные на сервер
  client.print(String("GET ") + url + " HTTP/1.1\r\n" +
               "Host: " + host + "\r\n" + 
               "Connection: close\r\n\r\n");
  delay(10);
   
  // ответ сервера
  String line;
  int k=0;
  while(client.available()){
    line = client.readStringUntil('\r');
    //Serial.print(line);
    if(k>0) k++;  
    if(line.substring(11,14)=="840")
      k=1;
    if(k==5) {
      if(dollar==line.substring(9,16)) ;
       else {
        dollar=line.substring(9,16);
        //Serial.println();Serial.print("dollar=");Serial.println(dollar);
        printer.println();
        printer.println(getTimeStr());
        printer.print("$= ");
        printer.print(dollar);        
        printer.print(" rub"); 
        printer.println();
      }
    }  
    delay(10);
  }
   
  //Serial.println();
  //Serial.println("closing connection");
}
 
// получить дату и время
void getDateDs3231() {
  Wire.beginTransmission(clockAddress);
  Wire.write(byte(0x00));
  Wire.endTransmission();
  Wire.requestFrom(clockAddress, 7);
 
  second     = bcdToDec(Wire.read() & 0x7f);
  minute     = bcdToDec(Wire.read());
  hour       = bcdToDec(Wire.read() & 0x3f);
  dayOfWeek  = bcdToDec(Wire.read());
  dayOfMonth = bcdToDec(Wire.read());
  day = dayOfMonth;
  month      = bcdToDec(Wire.read());
  year       = bcdToDec(Wire.read());
}


 
byte decToBcd(byte val) {
  return ( (val / 10 * 16) + (val % 10) );
} 
byte bcdToDec(byte val) {
  return ( (val / 16 * 10) + (val % 16) );
}
  
String getDateStr() {
  String str = String(day) + "/" + formatDigit(month, 2) + "/20" + 
      formatDigit(year, 2);
  return str;
}

String getTimeStr() {
  String str = String(day) + "." + formatDigit(month, 2) + "." + 
      formatDigit(year, 2) + " " + formatDigit(hour, 2) + ":" +
      formatDigit(minute, 2) + ":" + formatDigit(second, 2);
  return str;
}

String formatDigit(int i, int len) {
  String s = String(i);
  while (s.length() < len) {
    s = "0" + s;
  }
  return (s);
} 
 


