#!/usr/bin/python
import smbus
import time
 
# Установка констант по даташиту
DEVICE     = 0x23   # I2C адрес датчика
 
POWER_DOWN = 0x00   # Неактивное состояние 
POWER_ON   = 0x01   # Включение
RESET      = 0x07   # Сбросить значение регистра Не POWER_DOWN = 0x00 # 
 
# Запуск измерения с разрешением 4 lx. Время, как правило, 16 мс.
CONTINUOUS_LOW_RES_MODE = 0x13
# Запуск измерения с разрешением 1 lx. Время, как правило, 120 мс
CONTINUOUS_HIGH_RES_MODE_1 = 0x10
# Запуск измерения с разрешением 0.5 lx. Время, как правило, 120 мс
CONTINUOUS_HIGH_RES_MODE_2 = 0x11
# Запуск измерения с разрешением 1 lx. Время, как правило, 120 мс
# Устройство автоматически устанавливается на Power Down после измерения.
ONE_TIME_HIGH_RES_MODE_1 = 0x20
# Запуск измерения с разрешением 0.5 lx. Время, как правило, 120 мс
# Устройство автоматически устанавливается на Power Down после измерения.
ONE_TIME_HIGH_RES_MODE_2 = 0x21
# Запуск измерения с разрешением 1 lx. Время, как правило, 120 мс
# Устройство автоматически устанавливается на Power Down после измерения.
ONE_TIME_LOW_RES_MODE = 0x23 

#bus = smbus.SMBus(0) # Rev 1 Pi uses 0
bus = smbus.SMBus(1)  # Rev 2 Pi uses 1
 
def convertToNumber(data):
  # перевод данных датчика в числовое значение
  return ((data[1] + (256 * data[0])) / 1.2)
 
def readLight(addr=DEVICE):
  data = bus.read_i2c_block_data(addr,ONE_TIME_HIGH_RES_MODE_1)
  return convertToNumber(data)
 
def main():
 
  while True:
    print "Light Level : " + str(readLight()) + " lx"
    time.sleep(0.5)
   
if __name__=="__main__":
   main()

